<script lang="ts">
import Vue from 'vue';
import SlpPlayIcon from './play-icon.vue';

export default Vue.extend({
  name: 'SolutionsCarouselVideoCard',
  components: {
    SlpPlayIcon,
  },
  props: {
    video: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      isHovered: false,
    };
  },
  methods: {
    onCardClick() {
      this.$emit('click');
    },
  },
});
</script>

<template>
  <section
    class="container"
    @click="onCardClick"
    @mouseover="isHovered = true"
    @mouseleave="isHovered = false"
  >
    <div class="image__container">
      <img :src="video.photourl" :alt="video.title" />
      <div class="image__container--play">
        <SlpPlayIcon :is-active="isHovered" />
      </div>
    </div>
    <div class="text__container">
      <SlpTypography
        v-if="video.carousel_identifier[0]"
        tag="p"
        variant="body2"
        class="tag slp-text-align-left"
        >{{ video.carousel_identifier[0] }}</SlpTypography
      >
      <SlpTypography
        tag="h4"
        variant="heading4"
        class="title slp-text-align-left"
        >{{ video.title }}</SlpTypography
      >
    </div>
  </section>
</template>

<style lang="scss" scoped>
.container {
  padding: 0 0 $spacing-32 0;
  border-radius: $spacing-4;
  max-width: 350px;
  min-height: 350px;
  margin: 0 $spacing-16;
  color: $color-text-300;
  cursor: pointer;
  border: 1px solid $color-surface-200;
  transition: all 0.3s ease-in-out;
  -webkit-box-shadow: 0 1px 3px 0 rgba($color-surface-700, 0.1),
    0 1px 2px 0 rgba($color-surface-700, 0.06);
  -moz-box-shadow: 0 1px 3px 0 rgba($color-surface-700, 0.1),
    0 1px 2px 0 rgba($color-surface-700, 0.06);
  box-shadow: 0 1px 3px 0 rgba($color-surface-700, 0.1),
    0 1px 2px 0 rgba($color-surface-700, 0.06);
  &:hover {
    -webkit-box-shadow: 0 10px 15px -3px rgba($color-surface-700, 0.1),
      0 4px 6px -2px rgba($color-surface-700, 0.05);
    -moz-box-shadow: 0 10px 15px -3px rgba($color-surface-700, 0.1),
      0 4px 6px -2px rgba($color-surface-700, 0.05);
    box-shadow: 0 10px 15px -3px rgba($color-surface-700, 0.1),
      0 4px 6px -2px rgba($color-surface-700, 0.05);
  }
}
.image__container {
  position: relative;

  &--play {
    position: absolute;
    top: 40%;
    right: 45%;
  }
  img {
    width: 100%;
    height: 195px;
    border-bottom: 1px solid $color-surface-200;
  }
}

.text__container {
  padding: $spacing-16 $spacing-32 0 $spacing-32;
  white-space: normal;

  .tag {
    text-transform: uppercase;
    color: $color-text-300;
  }
}
</style>
